/* BkdCleanUp - Utilitie to delete appointments between two dates
   Copyright (C) 2002  Alexander Gross

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Stuff that we need
import waba.ui.*;
import waba.fx.*;
import waba.util.*;
import waba.sys.*;
import waba.io.*;
import extra.io.*;
import extra.io.builtin.*;

// go on with the main class
public class DbkCleanUp extends MainWindow {
	// Version
	static final String VERSION = "0.4";
	
	// Variable declaration
	ComboBox	spl;
	ComboBox	epl;
	Label		reml;
	Edit		stre;
	Edit		ende;
	Button		start;
	Check		cbx;
	MessageBox  mb;
	// delete counter
	int			cc = 0;
	// confirm box
	MessageBox	cbb;
	// create a new datebook class
	Datebook date = new Datebook();
	
	// constructor
	public DbkCleanUp() {
  		setDoubleBuffer(true);
  		setBorderStyle(TAB_ONLY_BORDER);
  		setTitle("DbkCleanUp");
  		Settings.setPalmOSStyle(true);
  		// attach the wextras library
  		Vm.attachLibrary("wextras.SWAB");
  	}
  	
  	// onstart
	public void onStart() {
		// paint the edits
		stre = new Edit();
		stre.setRect(95,30,60,15);
		add(stre);
		stre.setMode(Edit.DATE);
		ende = new Edit();
		ende.setRect(95,45,60,15);
		add(ende);
		ende.setMode(Edit.DATE);
		// paint the poplists
		spl  = new ComboBox(new String[]{"start date","purge until end"});
		spl.setRect(5,30,90,15);
		spl.select(0);
		add(spl);
		epl  = new ComboBox(new String[]{"end date","purge from start"});
		epl.setRect(5,45,90,15);
		epl.select(0);
		add(epl);
		// paint the button
		start = new Button("Purge");
		start.setRect(RIGHT-5,65,40,15);
		add(start);
		// paint the checkbox
		/*cbx = new Check("backup");
		cbx.setRect(LEFT+5,68,80,10);
		add(cbx);*/
		// and the label
		reml = new Label("DbkCleanUp purges the|appointments in Datebook|between two given dates.||Created with SuperWaba|http://www.superwaba.com", Label.CENTER);
		reml.setRect(10,85,140,90);
		add(reml);
	}

	// event handler
	public void onEvent(Event event) {
		// if button pressed
		if ((event.type == ControlEvent.PRESSED) && (event.target == start)) {
			// if nothing in the edits -> exit
			if ((stre.getText().length() < 1) || (ende.getText().length() < 1))
				exit(0);
			// else get the dates in the edits
			Date d  = new Date(stre.getText());
			int sdi = d.getDateInt();
			     d  = new Date(ende.getText());
			int edi = d.getDateInt();
			// loop counter
			int i  = 0;
			// indicator for finish
			boolean proc = true;
			int count = Datebook.datebookCount();
			if (count > 1) {
				// purging loop
				do {
					// check if a entry exists
					proc = Datebook.getDate(i, date);
					// get the date
					Time tobj = date.startDate;
					d = new Date(tobj.day+"."+tobj.month+"."+tobj.year);
					int cdi = d.getDateInt();
					// if date between the given dates
					if ((cdi >= sdi) && (cdi <= edi)) {
						// delete the entry
						boolean ok = date.delDate(i);
						if (ok) {
							cc++;
						}
						//}
					}
					i++;
				} while (proc);
				// message box when finished
				mb = new MessageBox("Work done", cc+" entries deleted", null);
				mb.dontSaveBehind(true);
				mb.setUnpopDelay(5000);
				popupModal(mb);
			} else {
				mb = new MessageBox("Nothing to do", "There are no entries|in your DatebookDB.", null);
				mb.dontSaveBehind(true);
				mb.setUnpopDelay(5000);
				popupModal(mb);
			}
		} else
		// if message box closes exit the program
		if ((event.type == ControlEvent.WINDOW_CLOSED) && (event.target == mb)) {
			exit(0);
		} else
		// if confirm box closes
		if ((event.type == ControlEvent.WINDOW_CLOSED) && (event.target == cbb)) {
			int i = cbb.getPressedButtonIndex();
			if (i == 0) {
				boolean ok = date.delDate(i);
				if (ok)
					cc++;
			} else {
				// do nothing
			}	
		} else
		// selectors for the poplists
		if ((event.type == ControlEvent.PRESSED) && (event.target == spl)) {
			int i = spl.getSelectedIndex();
			if (i == 0) {
				stre.setText("");
				stre.setEditable(true);
			} else
			if (i == 1) {
				stre.setText("01.01.1983");
				stre.setEditable(false);
			}
		} else
		if ((event.type == ControlEvent.PRESSED) && (event.target == epl)) {
			int i = epl.getSelectedIndex();
			if (i == 0) {
				ende.setText("");
				ende.setEditable(true);
			} else
			if (i == 1) {
				ende.setText("31.12.2999");
				ende.setEditable(false);
			}
		}
	}
}
